#ifndef MAMA_UTILS_H
#define MAMA_UTILS_H

#include "config.h"

#include <string.h>
#include <stdio.h>

#define MAMA_ERROR(...)\
  fprintf(stderr,__VA_ARGS__);\
  exit(-1)

#define MAMA_NOT_NULL( POINTER)\
  if (POINTER == NULL){\
    MAMA_ERROR( "NULL pointer found\n");\
  }

#define MAMA_FOPEN( F, FILENAME, FORMAT)\
  F = fopen( FILENAME, FORMAT);\
  if (F == NULL){\
    MAMA_ERROR("Can't open filename %s\n", FILENAME);\
  }

#define MAMA_CALLOC( P, TYPE, NB)\
  P = (TYPE*) ( calloc(sizeof(TYPE), NB));\
  if (P == NULL){\
    MAMA_ERROR("Failed to allocate memory\n");\
  }

#endif
