#include <astro.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

int main(int argc, char* argv[])
{
  double ra1 = 0.0, dec1 =0.0, ra2 = 0.0, dec2 = 0.0;
  double xpix, ypix;
  double ramean, decmean, rasigma, decsigma;
  int nbiter = 0.0;
  double diffra, diffdec;
  
  amd_wcs* wcs1 = NULL;
  pv_wcs* wcs2 = NULL;

  wcs1 = amd_wcs_load(argv[1]);
  wcs2 = pv_wcs_load(argv[2]);
  
  if (argc == 5){
    xpix = atof(argv[3]);
    ypix = atof(argv[4]);
  }

  ramean = decmean = rasigma = decsigma = 0.0;
  for(ypix=1.5; ypix < 28000; ypix+=256){
    for(xpix=1.5; xpix < 28000; xpix+=256){
      amd_xypix_to_radec( xpix, ypix, wcs1, &ra1, &dec1);
      pv_xypix_to_radec( xpix, ypix, wcs2, &ra2, &dec2);
      diffra = (ra1-ra2)*3600.0*cos(dec1*DEG_TO_RAD);
      diffdec = (dec1-dec2)*3600.0;
      printf("x %f y %f ra1 %.10E dec1 %.10E ra2 %.10E dec2 %.10E diffra %.10E diffdec %.10E\n",xpix,ypix,ra1,dec1,ra2,dec2,diffra, diffdec);
      ramean += diffra;
      decmean += diffdec;
      rasigma += diffra*diffra;
      decsigma +=  diffdec*diffdec;  
      nbiter++;
    }
  }
  ramean /=  nbiter;
  decmean /= nbiter;
  rasigma /= nbiter;
  decsigma /= nbiter;
  rasigma = sqrt(rasigma);
  decsigma = sqrt(decsigma); 
  printf("nbiter %d ramean %.10E decmean %.10E rasigma %.10E decsigma %.10E\n",nbiter, ramean,decmean,rasigma,decsigma);
  return 0;

  
/*	
  wcs1 = amd_wcs_load(argv[1]);
  xpix = atof(argv[2]);
  ypix = atof(argv[3]);
  amd_xypix_to_radec( xpix, ypix, wcs1, &ra1, &dec1);
  printf("x %.10E y %.10E ra1 %2.8E dec1 %2.8E\n",xpix,ypix,ra1,dec1);
  return 0;
*/
  /*  
 wcs2 = pv_wcs_load(argv[1]);
 xpix = atof(argv[2]);
 ypix = atof(argv[3]);
		  pv_xypix_to_radec( xpix, ypix, wcs2, &ra1, &dec1);
		  printf("x %.10E y %.10E ra1 %.10E dec1 %.10E\n",xpix,ypix,ra1,dec1);
  return 0;
  */
}
