#include <ctype.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <errno.h>
#include "mosreg.h"

/*
++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* pave_new
++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*/
atlas* atlas_new(char* filename,char* atlasname){
  atlas *result = NULL;
  FILE* file = NULL;
  char record[500];
  char* name = NULL;
  char field[6];
  int i,platenum;
  int general = 0; 


  result = (atlas*)(malloc(sizeof(atlas)));
  
  /* find the number of plate */
  name = strrchr(filename,'/');
  if ( name == NULL ){
      name=filename;
  }
  else{
    name = name+1;
  }
  if( (strncmp(name,"eso",3)==0)||(strncmp(name,"ESO",3)==0)|| 
    (strncmp(name,"SRC",3)==0) || (strncmp(name,"src",3)==0)){
    strncpy(result->fld,name+3,3);
    result->fld[3]=0;
    platenum = atoi(result->fld);
    sprintf(result->fld,"%03d",platenum);
    general = 1;
  }
  else {
    printf( "Local atlas mode\n");
  }
  if(atlasname != NULL){
    file = fopen(atlasname,"r");
    if (file == NULL) {
      error(-1,"Impossible d'ouvrir le fichier atlas");
    }
    else{
      if ( general) { 
        for(i=0;i<platenum;i++){         
          fgets(record,500,file); 
        }
        /* parse the record */
        sscanf(record,"FLD:%s PLTLABEL:%s EMULSION:%s FILTER:%s ALPHA_50:%s \
          DELTA_50:%s DATE-OBS:%s JDAY:%s LST_SOE:%s PLTDATE:%s EXPOSURE:%s \
          PLTGRADE:%[^\n]\n",field,result->pltlabel,result->emulsion,result->filter,
          result->alpha_50,result->delta_50,result->dateobs,result->jday,result->lst_soe,
          result->pltdate,result->exposure,result->pltgrade);
        if( strncmp(field+1,result->fld,3)!=0 ){
          error(-1,"can't find the plate in the atlas");
        }
      }
      else{
        fgets(record,500,file);

/*
 * PLTLABEL:'E1199' EMULSION:'103aE' FILTER:'Red-Plex-2444' ALPHA_50:'00:55:40' DELTA_50:'-23:35' DATE_OBS:'1954-09-04' MJDAY_S:'34990.39583' MJDAY_M:'34990.    41319' PLTDATE:'1954.67643' EXPOSURE:'50' PLTGRADE:'2-3'
 * */
        /* parse the record */
        sscanf(record,"PLTLABEL:%s EMULSION:%s FILTER:%s ALPHA_50:%s \
          DELTA_50:%s DATE_OBS:%s MJDAY_S:%s MJDAY_M:%s PLTDATE:%s EXPOSURE:%s \
          PLTGRADE:%[^\n]\n",result->pltlabel,result->emulsion,result->filter,
            result->alpha_50,result->delta_50,result->dateobs,result->mjday_s,result->mjday_m,
            result->pltdate,result->exposure,result->pltgrade);
        fclose(file);
      }
    }
  }
  else{
    error(-1,"Impossible de lire le nom du fichier atlas");
  }
  return result;
}
/*
----------------------------------------------------------------------------------------
*/
/*
++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* atlas_free
++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*/
void atlas_free(atlas* atlasfile){
  if(atlasfile){
    free(atlasfile);
  }
}
/*
----------------------------------------------------------------------------------------
*/
