#include <ctype.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <errno.h>
#include <math.h>

#include "mosreg.h"

/*
++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* pave_new
++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*/
wcs* wcs_new(char* file){
  wcs *result = NULL;
  char record[90];
  char value[40];
  int i;
   
  result = (wcs*)(malloc(sizeof(wcs)));
  
  result->nbKeys = 0;
  
  if(file != NULL){
    result->file = fopen(file,"r");
    if (result->file == NULL) {
      error(-1,"Impossible d'ouvrir le fichier wcs");
    }

    /* count the KW */
    while (fgets(record,90,result->file)){
      result->nbKeys++;
    }
    
    rewind(result->file);
    
    result->header = (char*)(malloc(sizeof(char)*result->nbKeys*80));
    if( result->header == NULL ){
      error(-1,"Impossible d'allouer de la mmoire pour le wcs");
    }
    
    for(i=0;i<result->nbKeys;i++){
      int j = 0;
      int deb;
      int end;
      fgets(record,90,result->file);
      while(record[j] ==' '){
        j++;
      }
      deb = j;
      for(j=deb;j<90;j++){
        if (record[j] == '\n'){
          record[j] = ' ';
	}
      }
      strncpy(&result->header[i*80],record+deb,80);
    } 
    if(fclose(result->file) !=0){
      error(-1,"Impossible de fermer le fichier wcs");
    }
    if(wcs_keyword_get(result,"YCZ",value)){
      result->ycz = atof(value);
    }
    else {
      error(-1,"YCZ introuvable dans le wcs");
    }
    if(wcs_keyword_get(result,"XCZ",value)){
      result->xcz = atof(value);
    }
    else {
      error(-1,"XCZ introuvable dans le wcs");
    }
  }
  return result;
}
/*
----------------------------------------------------------------------------------------
*/
/*
++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* pave_free
++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*/
void wcs_free(wcs* wcsfile){
  if(wcsfile){
    free(wcsfile);
  }
}
/*
----------------------------------------------------------------------------------------
*/
/*
/*
++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* wcs_keyword_get
++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*/
int wcs_keyword_get(wcs* wcsfile,char* keyword,char* value){
  int i;
  
  for(i=0;i<wcsfile->nbKeys;i++){
    char* line;
    
    line = &wcsfile->header[80*i];
    if( keyword_get(keyword,value,line) )return 1;
  }
  return 0;
}
/*
----------------------------------------------------------------------------------------
*/
/*
++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* wcs_keyword_set
++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*/
int wcs_keyword_set(wcs* wcsfile,char* keyword,char* value){
  int i,j,k;
  char oldvalue[30];
  

  for(i=0;i<wcsfile->nbKeys;i++){
    char* line;
    
    line = &wcsfile->header[80*i];
    if( keyword_get(keyword,oldvalue,line) ){
      int size;
      
      size = strlen(value);
      
      if(size > 70){
        size = 70;
      }
      for (j = 0; j < size; j++){
        if(line[10+ j]='/'){
	  for(k=j;k<size;k++){
	    line[10+k] = ' ';
	  }
	}
	line[10+j] = value[j];
      }
      return 1;
    }
  }
  return 0;
}
/*
----------------------------------------------------------------------------------------
*/
